from hashFunction import *
from OrderedList import *

class HashTable:
   def __init__(self,size):
      self.slots = [None] * size
      self.size = size
      for i in range(size):
         self.slots[i] = OrderedList()

   def hashfunction(self,item,size):
      return hashString(item,size)

   def store(self,item,data):
      hashvalue = self.hashfunction(item,len(self.slots))
      self.slots[hashvalue].add(item, data)

   def search(self,item):
      hashvalue = self.hashfunction(item,len(self.slots))
      return self.slots[hashvalue].search(item)
   
   # overloading __getitem__ and __setitem__ allows for access using [] as
   # myHashTable[33] = 'cat'
   # myHashTable[33]
   def __getitem__(self,item):
      return self.search(item)

   def __setitem__(self,item,data):
      self.store(item,data)

   def show(self):
      for i in range(self.size):
         print "Slot", i, ":",
         self.slots[i].show()
         print

   def showSizes(self):
      for i in range(self.size):
         print "Slot", i, ":", self.slots[i].length()
   
