from Node import *

class UnorderedList:
    def __init__(self):
        self.head = None
        self.itemCount = 0

    def isEmpty(self):
        return self.head == None

    def add(self, item, data):
        temp = Node(item, data)
        temp.setNext(self.head)
        self.head = temp
        self.itemCount += 1

    def length(self):
        return self.itemCount
    
    def search(self,item):
        current = self.head
        while current != None:
            if current.getKey() == item:
                return current.getKey()
            else:
                current = current.getNext()

        return None

    def remove(self,item):
        current = self.head
        previous = None
        found = False
        while not found:
            if current.getKey() == item:
                found = True
            else:
                previous = current
                current = current.getNext()

        if previous == None:
            self.head = current.getNext()
        else:
            previous.setNext(current.getNext())
        self.itemCount -= 1
# end class UnorderedList


